/**
Action Script library. Array class definition
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_ARRAY_HH
#define _AS_ARRAY_HH
#include "as_object.hh"

class ASArray : public ASObject {
public:
	ASArray(Script *s, Graphics *g);
	~ASArray();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *f);
	void 	init();
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASArray(s,g); }
	void 	setMember(wstring memberName, ValueObject *v);
	ValueObject*getMember(wstring memberName);
	void	allocate(int nbElements);
	ValueObject*getMainMember();

	void	concat();
	void	join();
	void	pop();
	void	push();
	void	reverse();
	void	shift();
	void	slice();
	void	sort();
	void	sortOn();
	void	splice();
	void	AStoString();
	void	unshift();
	int		ASLength();
private:
	ValueObject**array;
	int 	arrayLen;
	int 	maxPosition;
};
#endif
