/**
Action Script library. Math class definition
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_MATH_HH
#define _AS_MATH_HH
#include "as_object.hh"

class ASMath : public ASObject{
public:
	ASMath(Script *s, Graphics *g);
	~ASMath();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *f);
	void 	init();
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASMath(s,g); }

	void	asabs();
	void	asacos();
	void	asasin();
	void	asatan();
	void	asatan2();
	void	asceil();
	void	ascos();
	void	asexp();
	void	asfloor();
	void	aslog();
	void	asmax();
	void	asmin();
	void	aspow();
	void	random();
	void	asround();
	void	assin();
	void	assqrt();
	void	astan();
};
#endif
