/**
Action Script library. Microphone class implementation
Copyright (C) 2005  

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_microphone.hh"

typedef void (ASMicrophone::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASMicrophone::init,			// 0
	&ASMicrophone::get,				// 1
	&ASMicrophone::setGain,			// 2
	&ASMicrophone::setRate,			// 3
	&ASMicrophone::setSilenceLevel,	// 4
	&ASMicrophone::setUseEchoSuppression,//5
	&ASMicrophone::silenceLevel,	//6
	&ASMicrophone::silenceTimeout,	//7
	&ASMicrophone::useEchoSuppression,//8
	// Need to be at the end.
	&ASMicrophone::addProperty,		
	&ASMicrophone::registerClass,	
	&ASMicrophone::AStoString,		
	&ASMicrophone::unwatch,			
	&ASMicrophone::valueOf,			
	&ASMicrophone::watch		
};

/**
 * The constructor
 **/
ASMicrophone::ASMicrophone(Script *s, Graphics *g) : ASObject(s,g,L"Microphone") {
}

/**
 * The destructor
 **/
ASMicrophone::~ASMicrophone() {
}

/**
 * Return a function descriptor
 */
Function *ASMicrophone::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"Microphone") 		{func->setFunctionIndex(0); func->setNumParams(0); } 
	if (memberName == L"get") 				{func->setFunctionIndex(1); func->setNumParams(1); } 
	if (memberName == L"setGain") 			{func->setFunctionIndex(2); func->setNumParams(1); } 
	if (memberName == L"setRate") 			{func->setFunctionIndex(3); func->setNumParams(1); } 
	if (memberName == L"setSilenceLevel") 	{func->setFunctionIndex(4); func->setNumParams(2); } 
	if (memberName == L"setUseEchoSuppression"){func->setFunctionIndex(5); func->setNumParams(1); } 
	if (memberName == L"silenceLevel") 		{func->setFunctionIndex(6); func->setNumParams(0); } 
	if (memberName == L"silenceTimeout") 	{func->setFunctionIndex(7); func->setNumParams(0); } 
	if (memberName == L"useEchoSuppression") {func->setFunctionIndex(8); func->setNumParams(0); } 
	finishFunctionSetup(memberName,9,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASMicrophone::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASMicrophone::init() {
	puts("TODO - ASMicrophone::init()");
}

/**
 * Returns a default or specified Microphone object, or null if the microphone is not available.
 **/
void ASMicrophone::get() {
	puts("TODO - ASMicrophone::get()");
	noReturnValue();
}

/**
 * Specifies the amount by which the microphone should boost the signal.
 **/
void ASMicrophone::setGain() {
	puts("TODO - ASMicrophone::setGain()");
	noReturnValue();
}

/**
 * Specifies the rate at which the microphone should capture sound, in kHz.
 **/
void ASMicrophone::setRate() {
	puts("TODO - ASMicrophone::setRate()");
	noReturnValue();
}

/**
 * Specifies the amount of sound required to activate the microphone.
 **/
void ASMicrophone::setSilenceLevel() {
	puts("TODO - ASMicrophone::setSilenceLevel()");
	noReturnValue();
}

/**
 *  Specifies whether to use the echo suppression feature of  the audio codec.
 **/
void ASMicrophone::setUseEchoSuppression() {
	puts("TODO - ASMicrophone::setUseEchoSuppression()");
	noReturnValue();
}

/**
 * The amount of sound required to activate the microphone.
 **/
void ASMicrophone::silenceLevel() {
	puts("TODO - ASMicrophone::silenceLevel()");
	noReturnValue();
}

/**
 * The number of milliseconds between the time the microphone stops detecting sound and the time Microphone.onActivity(false) is called.
 **/
void ASMicrophone::silenceTimeout() {
	puts("TODO - ASMicrophone::silenceTimeout()");
	noReturnValue();
}

/**
 * A Boolean value that specifies whether echo suppression is being used.
 **/
void ASMicrophone::useEchoSuppression() {
	puts("TODO - ASMicrophone::useEchoSuppression()");
	noReturnValue();
}


