/**
Action Script library. PrintJob class implementation
Copyright (C) 2005 

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_print_job.hh"

typedef void (ASPrintJob::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASPrintJob::init,			// 0
	&ASPrintJob::start,			// 1
	&ASPrintJob::addPage,		// 2
	&ASPrintJob::send,			// 3
	// Need to be at the end.
	&ASPrintJob::addProperty,		
	&ASPrintJob::registerClass,	
	&ASPrintJob::AStoString,		
	&ASPrintJob::unwatch,			
	&ASPrintJob::valueOf,			
	&ASPrintJob::watch
};

/**
 * The constructor
 **/
ASPrintJob::ASPrintJob(Script *s, Graphics *g) : ASObject(s,g,L"PrintJob") {
}

/**
 * The destructor
 **/
ASPrintJob::~ASPrintJob() {
}

/**
 * Return a function descriptor
 */
Function *ASPrintJob::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"PrintJob") 	{func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"start") 	{func->setFunctionIndex(1); func->setNumParams(0); }
	if (memberName == L"addPage") 	{func->setFunctionIndex(2); func->setNumParams(4); }
	if (memberName == L"send") 		{func->setFunctionIndex(3); func->setNumParams(0); }
	finishFunctionSetup(memberName,4,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASPrintJob::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}
/**
 *
 **/
void ASPrintJob::init() {
	puts("TODO - ASPrintJob::init()");
}

/**
 * Displays the operating system’s print dialog boxes and starts spooling.
 **/
void ASPrintJob::start() {
	puts("TODO - ASPrintJob::start()");
	noReturnValue();
}

/**
 * Adds one page to the print spooler.
 **/
void ASPrintJob::addPage() {
	puts("TODO - ASPrintJob::addPage()");
	noReturnValue();
}

/**
 * Sends spooled pages to the printer.
 **/
void ASPrintJob::send() {
	puts("TODO - ASPrintJob::send()");
	noReturnValue();
}
