/**
Action Script library. SystemSecurity class implementation
Copyright (C) 2005  

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_system_security.hh"

typedef void (ASSystemSecurity::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASSystemSecurity::init,			// 0
	&ASSystemSecurity::allowDomain,		// 1
	&ASSystemSecurity::allowInsecureDomain, //2
	// Need to be at the end.
	&ASSystemSecurity::addProperty,		
	&ASSystemSecurity::registerClass,	
	&ASSystemSecurity::AStoString,		
	&ASSystemSecurity::unwatch,			
	&ASSystemSecurity::valueOf,			
	&ASSystemSecurity::watch
};

/**
 * The constructor
 **/
ASSystemSecurity::ASSystemSecurity(Script *s, Graphics *g) : ASObject(s,g,L"System.security") {
}

/**
 * The destructor
 **/
ASSystemSecurity::~ASSystemSecurity() {
}

/**
 * Return a function descriptor
 */
Function *ASSystemSecurity::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"System.security") 	{func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"allowDomain") 		{func->setFunctionIndex(1); func->setNumParams(10); } // illimited
	if (memberName == L"allowInsecureDomain"){func->setFunctionIndex(2); func->setNumParams(1); }
	finishFunctionSetup(memberName,3,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASSystemSecurity::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASSystemSecurity::init() {
	puts("TODO - ASSystemSecurity::init()");
}

/**
 * Allows SWF files in the identified domains to access objects and variables in the calling SWF file, or in any other SWF file 
 * from the same domain as the calling SWF file.
 **/
void ASSystemSecurity::allowDomain() {
	puts("TODO - ASSystemSecurity::allowDomain()");
	noReturnValue();
}

/**
 * Allows SWF files in the identified domains to access objects and variables in the calling SWF file, which is hosted using the HTTPS protocol.
 **/
void ASSystemSecurity::allowInsecureDomain() {
	puts("TODO - ASSystemSecurity::allowInsecureDomain()");
	noReturnValue();
}

