/**
Action Script library. TextFormat class implementation
Copyright (C) 2005   Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_text_format.hh"

typedef void (ASTextFormat::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASTextFormat::init,			// 0
	&ASTextFormat::getTextExtent,	// 1
	// Need to be at the end.
	&ASTextFormat::addProperty,		
	&ASTextFormat::registerClass,	
	&ASTextFormat::AStoString,		
	&ASTextFormat::unwatch,			
	&ASTextFormat::valueOf,			
	&ASTextFormat::watch
};

/**
 * The constructor
 **/
ASTextFormat::ASTextFormat(Script *s, Graphics *g) : ASObject(s,g,L"TextFormat") {
}

/**
 * The destructor
 **/
ASTextFormat::~ASTextFormat() {
}

/**
 * Return a function descriptor
 */
Function *ASTextFormat::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"TextFormat") 	{func->setFunctionIndex(0); func->setNumParams(13); }
	if (memberName == L"getTextExtent") 	{func->setFunctionIndex(1); func->setNumParams(2); }
	finishFunctionSetup(memberName,2,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASTextFormat::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASTextFormat::init() {
	puts("TODO - ASTextFormat::init()");
}

/**
 *  Returns text measurement information for a text string.
 **/
void ASTextFormat::getTextExtent() {
	puts("TODO - ASTextFormat::getTextExtent()");
	noReturnValue();
}
